/*
 * Sunshine's Desktop Symbol Utility V1
 *
 * This is the loader application which injects a dll into explorer process
 * in order to modify text/background color of the desktop symbols.
 */

#include <windows.h>
#include <commctrl.h>
#include <Tlhelp32.h.>

#include "ToolTip.h"
#include "DesktopSymbolDll\shared.h"
#include "resource.h"

//#pragma comment(linker, "/NODEFAULTLIB")
//#pragma comment(linker,"/ENTRY:WinMain")

// My Visual Studio does not know the constant SPI_SETDROPSHADOW, so I have to
// define it myself if necessary
#ifndef SPI_SETDROPSHADOW
	#define SPI_SETDROPSHADOW  0x1025
#endif

// some constants for task bar notification icon handling
#define ICON_NOTIFY 0x9000
#define WM_NOTIFYICON  WM_APP + 100

#define DUMPFILE	"info.dump"			// filename to save values


/*
 *** Global variables
 */

	HWND		hList;					// handle to loglist

	LPSTR		szAutoStart = " -autostart";				// autostart option for cmdline

	LPSTR		szDllName = "DesktopSymbolDll.dll";			// name of our dll to inject
	HMODULE 	hKernel32 = GetModuleHandle("Kernel32");	// handle to kernel32.dll

	HANDLE 		hProcess;				// handle to target process
	HANDLE 		hThread;				// handle to our remote thread
	void*		pRemoteMem;				// pointer to memory in target process
	char		szFileName[MAX_PATH];	// hold complete path to this application
	DWORD		hLibModule;				// will receive thread exit code


	HWND 		hDesktopListview;		// handle to 'SHELLDLL_DefView' window, child of 'progman'
	HWND 		hListView;				// handle to 'SysListview32' window, child of 'SHELLDLL_DefView'



	RECT		textColorPreviewRect = { 205, 22, 225, 37 };
	RECT		textBgColorPreviewRect = { 205, 44, 225, 59 };


BOOL AboutBoxProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);


/*
 * Add given string to the end of loglist
 */
void AddToList(LPSTR s)
{
	SendMessage(hList, LB_INSERTSTRING, -1, (LPARAM)s);
}





/****************************************************************
 * Registry helper functions
 ***************************************************************/

/*
 * Read a DWORD from specified registry key
 */
BOOL GetRegDword(LPSTR szKeyName, LPSTR szValueName, LPDWORD retValue)
{
	HKEY		hKey;
	DWORD		dwSize;
	DWORD		dwType;

	if (RegOpenKeyEx(HKEY_CURRENT_USER, szKeyName, 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS)
	{
		if (RegQueryValueEx(hKey, szValueName, 0, &dwType, (LPBYTE)retValue, &dwSize) == ERROR_SUCCESS)
		{
			RegCloseKey(hKey);
			return TRUE;
		}
	}
	return FALSE;
}

/*
 * Save a DWORD to specified registry key
 */
BOOL SaveRegDword(LPSTR szKeyName, LPSTR valueName, DWORD dwToSave)
{
	HKEY		hKey;
	DWORD		dwDisPos;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, szKeyName, 0, 0, REG_OPTION_NON_VOLATILE,
						KEY_WRITE, 0, &hKey, &dwDisPos) == ERROR_SUCCESS)
	{
		if (RegSetValueEx(hKey, valueName, 0, REG_DWORD, (LPBYTE)&dwToSave, 4) == ERROR_SUCCESS)
		{
			RegCloseKey(hKey);
			return TRUE;
		}

	}
	return FALSE;
}


/*
 * Read a string from specified registry key
 */
BOOL GetRegString(LPSTR szKeyName, LPSTR szValueName, LPSTR retValue, LPDWORD length)
{
	HKEY		hKey;
	DWORD		dwType = REG_SZ;

	if (RegOpenKeyEx(HKEY_CURRENT_USER, szKeyName, 0, KEY_READ, &hKey) == ERROR_SUCCESS)
	{
		if (RegQueryValueEx(hKey, szValueName, 0, &dwType, (LPBYTE)retValue, length) == ERROR_SUCCESS)
		{
			RegCloseKey(hKey);
			return TRUE;
		}
	}
	RegCloseKey(hKey);
	return FALSE;
}


/*
 * Save a string to specified registry key
 */
BOOL SaveRegString(LPSTR szKeyName, LPSTR valueName, LPSTR szToSave)
{
	HKEY		hKey;
	DWORD		dwDisPos;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, szKeyName, 0, 0, REG_OPTION_NON_VOLATILE,
						KEY_WRITE, 0, &hKey, &dwDisPos) == ERROR_SUCCESS)
	{
		if (RegSetValueEx(hKey, valueName, 0, REG_SZ, (LPBYTE)szToSave, lstrlen(szToSave)) == ERROR_SUCCESS)
		{
			RegCloseKey(hKey);
			return TRUE;
		}

	}
	return FALSE;
}


/****************************************************************
 * END Registry helper functions
 ***************************************************************/


/*
 * This dumps important values to file, so we can close this app und start it later again
 * and will be able to unload dll from target process
 */
BOOL DumpInfoToFile()
{
	char filename[MAX_PATH];
	GetModuleFileName(0, filename, MAX_PATH);

	int len = lstrlen(filename);
	for (int i = len; i > 0; i--)
	{
		if (filename[i] == '\\')
			break;
		else
			filename[i] = 0;
	}
	lstrcat(filename, DUMPFILE);

	HANDLE hFile = CreateFile(filename, GENERIC_WRITE | GENERIC_READ, 0, NULL,
								CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		AddToList("WARNING: Could not create info.dmp!");
		return FALSE;
	}

	DWORD bw;

	if ((WriteFile(hFile, (LPCVOID)&hThread, sizeof(HANDLE), &bw, NULL)) &&
		(WriteFile(hFile, (LPCVOID)&pRemoteMem, sizeof(void*), &bw, NULL)) &&
		(WriteFile(hFile, szFileName, MAX_PATH, &bw, NULL)) &&
		(WriteFile(hFile, (LPCVOID)&hLibModule, sizeof(DWORD), &bw, NULL)) )
		AddToList("Dumping variables to file done!");
	else
		AddToList("WARNING: Could not save all needed values to file!");

	CloseHandle(hFile);
	return TRUE;
}


/*
 * This loads the stored variable-values from our dumped file
 */
BOOL LoadInfoFromFile()
{
	HANDLE hFile = CreateFile(DUMPFILE, GENERIC_READ, 0, NULL,
								OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		AddToList("No saved values found...");
		return FALSE;
	}

	DWORD br;
	if ((ReadFile(hFile, (LPVOID)&hThread, sizeof(HANDLE), &br, NULL)) &&
		(ReadFile(hFile, (LPVOID)&pRemoteMem, sizeof(void*), &br, NULL)) &&
		(ReadFile(hFile, szFileName, MAX_PATH, &br, NULL)) &&
		(ReadFile(hFile, (LPVOID)&hLibModule, sizeof(DWORD), &br, NULL)) )
		AddToList("All data successfully read.");
	else
		AddToList("WARNING: Could not load all data! Unloading will probably fail.");

	CloseHandle(hFile);
	return TRUE;
}


/*
 * Save chosen colors to registry
 */
BOOL SaveColorsToReg()
{
	LPSTR	key = "Software\\Sunshine2k\\DeskSym";
	LPSTR	value = "TextColor";

	BOOL	ret1, ret2;
	ret1 = SaveRegDword(key, value, (DWORD)textColor);
	value = "TextBgColor";
	ret2 = SaveRegDword(key, value, (DWORD)textBgColor);
	return ( ret1 && ret2);
}

/*
 * Try to load saved color values from registry
 */
void GetColorsFromReg()
{
	char buf[MAX_PATH];
	LPSTR	key = "Software\\Sunshine2k\\DeskSym";
	LPSTR	value = "TextColor";

	if (!GetRegDword(key, value, &textColor))
		textColor = RGB(0,0,0);
	wsprintf(buf, "Text Color loaded: %08X.", textColor);
	AddToList(buf);

	value = "TextBgColor";
	if (!GetRegDword(key, value, &textBgColor))
		textBgColor = RGB(255,255,255);
	wsprintf(buf, "Text Background Color loaded: %08X.", textBgColor);
	AddToList(buf);
	return;
}


/*
 * Check if OS is at least Windows XP
 */
BOOL isWindowsXP()
{
	OSVERSIONINFO osInfo;
	osInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osInfo);
	return (osInfo.dwMajorVersion >= 5 && osInfo.dwMinorVersion >= 1);
}


/*
 * Check if drop shadows are enabled
 */
BOOL isDropShadowEnabled()
{
	LPSTR	key = "Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Advanced";
	LPSTR	value = "ListviewShadow";
	DWORD	retValue;

	BOOL result = GetRegDword(key, value, &retValue);
	return (result && retValue == 1);
}

/*
 * Disable drop shadows
 */
BOOL DisableDropShadows()
{
	LPSTR	key = "Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Advanced";
	LPSTR	value = "ListviewShadow";

	return  SaveRegDword(key, value, 0);
}


/*
 * Enable drop shadows
 */
BOOL EnableDropShadows()
{
	LPSTR	key = "Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Advanced";
	LPSTR	value = "ListviewShadow";

	return  SaveRegDword(key, value, 1);
}

/*
 * check if autostart is already enabled
 */
BOOL isAutoStartEnabled()
{
	LPSTR	key = "Software\\Microsoft\\Windows\\CurrentVersion\\Run";
	LPSTR	value = "SunDesktopSymbol";

	char	buf[MAX_PATH];
	DWORD	length = MAX_PATH;
	return	( (GetRegString(key, value, buf, &length)) && (length > 0));
}

/*
 * Enable autostart option
 */
BOOL EnableAutoStart()
{
	LPSTR	key = "Software\\Microsoft\\Windows\\CurrentVersion\\Run";
	LPSTR	value = "SunDesktopSymbol";

	char	filename[MAX_PATH];
	GetModuleFileName(0, filename, MAX_PATH);
	lstrcat(filename, szAutoStart);
	return SaveRegString(key, value, filename);
}

/*
 * Enable autostart option
 */
BOOL DisableAutoStart()
{
	LPSTR	key = "Software\\Microsoft\\Windows\\CurrentVersion\\Run";
	LPSTR	value = "SunDesktopSymbol";

	HKEY	hKey;
	BOOL	result = FALSE;
	if (RegOpenKeyEx(HKEY_CURRENT_USER, key, 0, KEY_SET_VALUE, &hKey) == ERROR_SUCCESS)
	{
		result = (RegDeleteValue(hKey, value) == ERROR_SUCCESS);
		RegCloseKey(hKey);
	}
	return result;
}


/*
 * Check if plugin is already activated by searching for our dll in explorer.exe process
 */
BOOL isInjected()
{
	HANDLE		hProcessSnap = NULL;
	BOOL		bFound = FALSE;

	// make a snapshot of all running processes
	hProcessSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if (hProcessSnap == INVALID_HANDLE_VALUE)
	{
		AddToList("ERROR: Could not make a process snapshot!");
		return FALSE;
	}

	PROCESSENTRY32 pe32;
	pe32.dwSize = sizeof(PROCESSENTRY32);

	// iterate through all processes
	if (Process32First(hProcessSnap, &pe32))
	{
		// search for explorer process
		do
		{
			if (lstrcmp(pe32.szExeFile, "explorer.exe") == 0)
			{
				// found, so search for our dll
				HANDLE hModuleSnap = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, pe32.th32ProcessID);
				if (hModuleSnap== INVALID_HANDLE_VALUE)
				{
					AddToList("ERROR: Could not make a module snapshot!");
					return FALSE;
				}

				MODULEENTRY32 me32;
				me32.dwSize = sizeof(MODULEENTRY32);

				// iterate through all loaded dlls
				if (Module32First(hModuleSnap, &me32))
				{
					do
					{
						if (lstrcmp(me32.szModule, szDllName) == 0)
						{
							bFound = TRUE;
							break;
						}
					}
					while (Module32Next(hModuleSnap, &me32));
				}
				CloseHandle(hModuleSnap);
			}
		}
		while (!bFound && Process32Next(hProcessSnap, &pe32));
	}

	CloseHandle(hProcessSnap);
	return bFound;
}



/*
 * This injects our dll in target process
 */
BOOL Inject()
{
	char	buf[MAX_PATH];
			ZeroMemory(buf, MAX_PATH);

	// get process id associated with listview window
	DWORD ProcessID, ThreadID;
	ThreadID = GetWindowThreadProcessId(hListView, &ProcessID);
	wsprintf(buf, "Notepad Process ID: %08X,   Thread ID: %08X", ProcessID, ThreadID);
	AddToList(buf);

	// now we can open target process (in fact, this is explorer.exe)
	hProcess = OpenProcess(PROCESS_ALL_ACCESS ,
					FALSE, ProcessID);
	wsprintf(buf, "Process Handle %08X", hProcess);
	AddToList(buf);
	if (hProcess == NULL)
	{
		AddToList("Failed while accessing target process... Aborting.");
		return FALSE;
	}

	// build complete path to our dll; for this we get path to our application including filename
	// then remove the app filename and append the dll filename
	GetModuleFileName(0, szFileName, MAX_PATH);
	wsprintf(buf, "Current path: %s", szFileName);
	AddToList(buf);

	int len = lstrlen(szFileName);
	for (int i = len; i > 0; i--)
	{
		if (szFileName[i] == '\\')
			break;
		else
			szFileName[i] = 0;
	}

	lstrcat(szFileName, szDllName);
	wsprintf(buf, "Dll path: %s", szFileName);
	AddToList(buf);

	// allocate memory in target process
	pRemoteMem = VirtualAllocEx(hProcess, NULL, sizeof(szFileName),
                               MEM_COMMIT, PAGE_READWRITE );
	if (pRemoteMem == NULL)
	{
		AddToList("Could not allocate remote memory...Aborting.");
		CloseHandle(hProcess);
		return FALSE;
	}
	AddToList("Memory allocated");

	// write the path to our dll in remote memory
	if (WriteProcessMemory( hProcess, pRemoteMem, (void*)szFileName,
                      sizeof(szFileName), NULL ))
		AddToList("Path in memory written!");
	else		// failed
	{
		AddToList("Writing to memory failed!... Aborting.");
		VirtualFreeEx( hProcess, pRemoteMem, sizeof(szFileName), MEM_RELEASE );
		CloseHandle(hProcess);
		return FALSE;
	}


	// Load our dll into the remote process
	hThread = CreateRemoteThread( hProcess, NULL, 0,
										(LPTHREAD_START_ROUTINE)GetProcAddress( hKernel32, "LoadLibraryA" ),
										pRemoteMem, 0, NULL );
	WaitForSingleObject( hThread, INFINITE );
	if (hThread == NULL)
	{
		AddToList("RemoteThread failed");
		CloseHandle(hProcess);
		return FALSE;
	}
	else
	{
		wsprintf(buf, "Thread successfully created! (Handle: %08X)", hThread);
		AddToList(buf);
	}

	// Get handle of the loaded module
	GetExitCodeThread( hThread, &hLibModule );

	// Clean up
	CloseHandle( hThread );

	AddToList("Injecting done!");

	return TRUE;
}


/*
 * Unload dll from target process
 */
void UnLoad()
{
	AddToList("Beginning unloading...");

	// we have to get a new handle to the process, cause when we restart the app later
	// for unloading, the old handle is invalid
	DWORD ProcessID;
	DWORD ThreadID = GetWindowThreadProcessId(hListView, &ProcessID);
	hProcess = OpenProcess(PROCESS_ALL_ACCESS ,
					FALSE, ProcessID);

	// free allocated memory in target process
	if (!VirtualFreeEx( hProcess, pRemoteMem, sizeof(szFileName), MEM_RELEASE ))
	{
		AddToList("WARNING: Freeing memory failed...");
	}
	if( hLibModule == NULL )
	{
		AddToList("Could not free allocated remote memory");
		//return;
	}

	// unload our dll from the remote process
	hThread = CreateRemoteThread( hProcess,
                NULL, 0,
                (LPTHREAD_START_ROUTINE) GetProcAddress(hKernel32,"FreeLibrary"),
                (void*)hLibModule,
                 0, NULL );

	if( hThread == NULL )	// failed to unload
	{
		AddToList("Unloading dll from remote process failed!");
		return;
	}

	WaitForSingleObject( hThread, INFINITE );
	GetExitCodeThread( hThread, &hLibModule );
	CloseHandle( hThread );
	CloseHandle(hProcess);
	AddToList("UnLoadinf Done!");
}


/*
 * Check if dll is injected in target process; true means yes, false no
 */
BOOL CheckStatus(HWND hwnd)
{

	// check status
	if (isInjected())
	{
		AddToList("Status: Active! (Dll is injected.)");
		ShowWindow(GetDlgItem(hwnd, ID_STATUSLABEL), SW_SHOW);
		ShowWindow(GetDlgItem(hwnd, ID_STATUSLABEL_INAC), SW_HIDE);
		return TRUE;
	}
	else

	{

		AddToList("Status: Inactive! (Dll is not loaded.)");
		ShowWindow(GetDlgItem(hwnd, ID_STATUSLABEL), SW_HIDE);
		ShowWindow(GetDlgItem(hwnd, ID_STATUSLABEL_INAC), SW_SHOW);
		return FALSE;
	}

}


/****************************************************************
 * TNA functions
 ***************************************************************/

/*
 * This adds an icon to the taskbar notification area
 */
void AddToTray(HWND hwnd)
{
	NOTIFYICONDATA nid;

	nid.cbSize = sizeof(NOTIFYICONDATA);
	nid.hWnd = hwnd;
	nid.uID = ICON_NOTIFY;
	nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	nid.uCallbackMessage = WM_NOTIFYICON;
	nid.hIcon = (HICON)LoadImage(GetModuleHandle(0), MAKEINTRESOURCE(IDI_ICON1),
									IMAGE_ICON, 32,32,0);
	lstrcpy(nid.szTip, "Sunshine's Desktop Symbol Utility");
	Shell_NotifyIcon(NIM_ADD, &nid);
}

/*
 * This remove the icon from the taskbar notification area
 */
void RemoveFromTray(HWND hwnd)
{
	NOTIFYICONDATA nid;

	nid.cbSize = sizeof(NOTIFYICONDATA);
	nid.hWnd = hwnd;
	nid.uID = ICON_NOTIFY;
	Shell_NotifyIcon(NIM_DELETE, &nid);
}


/****************************************************************
 * END TNA functions
 ***************************************************************/



/*
 * This draws a little rectangle in the specified color
 */
void DrawTextColorPreview(HWND hTextColorBox, RECT* rect, COLORREF color)
{
	HDC hdc = GetDC(hTextColorBox);
	if (hdc == NULL) return;

	Rectangle(hdc, rect->left - 2, rect->top - 2,
				   rect->right + 2, rect->bottom + 2);

	HBRUSH brush = CreateSolidBrush(color);
	FillRect(hdc, rect, brush);
	DeleteObject(brush);
	ReleaseDC(hTextColorBox, hdc);
}


/*
 * Shows a 'Choose Color' dialog and updates color variable with chosen color
 */
void ShowColorDialog(HWND hwnd, COLORREF* color)
{
	CHOOSECOLOR	cc;
	static COLORREF acrCustClr[16]; // array of custom colors

	ZeroMemory(&cc, sizeof(cc));
	cc.lStructSize = sizeof(cc);
	cc.lpCustColors = (LPDWORD) acrCustClr;
	cc.hwndOwner = hwnd;
	cc.Flags = CC_RGBINIT;
	cc.rgbResult = *color;
	if (ChooseColor(&cc))		// user chose a new color
	{
		*color = cc.rgbResult;
	}
}

/*
 * the standard window procedure for our dialog
 */
BOOL DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{

	switch(msg)
	{
	// Bye :-)
	case WM_CLOSE:
		{
			if (CheckStatus(hwnd))
			{
				if (MessageBox(hwnd, "Do you want to unload dll before closing? \n"
					"(Note: you can also deactivate it later by restarting the programm.)",
								"Still active... Unloading?", MB_YESNO) == IDYES)
				{
					bActivate = TRUE;
					UnLoad();
					bActivate = FALSE;
				}
				else
					DumpInfoToFile();
			}

			SystemParametersInfo(SPI_SETDROPSHADOW,NULL, FALSE, SPIF_SENDCHANGE|SPIF_UPDATEINIFILE);
			DeleteToolTip();
			SaveColorsToReg();
			EndDialog(hwnd, 0);
		}
		break;


	case WM_PAINT:
		{
			DrawTextColorPreview(GetDlgItem(hwnd, ID_TEXTCOLORBOX),
										 &textColorPreviewRect, textColor);

			// don't draw preview rect for background color if transparent is selected
			if (SendMessage(GetDlgItem(hwnd, ID_RADIOCOLOR),
							BM_GETCHECK, 0, 0) == BST_CHECKED)
				DrawTextColorPreview(GetDlgItem(hwnd, ID_TEXTBGCOLORBOX),
										 &textBgColorPreviewRect, textBgColor);

			return 0;
		}
		break;

	// give standard controls another color
	case WM_CTLCOLORDLG:
	case WM_CTLCOLORSTATIC:
		{
			HDC hdc = (HDC)wParam;
			if ((HWND)lParam == GetDlgItem(hwnd, ID_STATUSLABEL))
			{
				SetTextColor(hdc, RGB(0,255,0));	// 'active' in green color
			}
			else if ((HWND)lParam == GetDlgItem(hwnd, ID_STATUSLABEL_INAC))
			{
				SetTextColor(hdc, RGB(255,0,0));	// 'inactive' in red color
			}

			return (BOOL)(GetStockObject(WHITE_BRUSH));
		}
		break;

	// allow dragging the dialog with the mouse
	case WM_LBUTTONDOWN:
		{
			ReleaseCapture();
			SendMessage(hwnd, WM_SYSCOMMAND, 0xf012, 0);
		}
		break;




	case WM_INITDIALOG:
		{
			char	buf[MAX_PATH];
			ZeroMemory(buf, MAX_PATH);

			// get handle to loglist
			hList = GetDlgItem(hwnd, ID_LIST);

			// first get handle to listview window of desktop
			hDesktopListview = FindWindowEx(FindWindow("Progman", 0), 0, "SHELLDLL_DefView", 0);
			hListView = FindWindowEx(hDesktopListview, 0, "SysListView32", 0);
			if (hListView != NULL)
				AddToList("Desktop window found...");

			// get current text (background) color
			textColor = (COLORREF)SendMessage(hListView, LVM_GETTEXTCOLOR, 0, 0);
			textBgColor = (COLORREF)SendMessage(hListView, LVM_GETTEXTBKCOLOR, 0, 0);

			// enable color radio button
			SendMessage(GetDlgItem(hwnd, ID_RADIOCOLOR), BM_SETCHECK, BST_CHECKED, 0);

			// resize & center dialog
			RECT rect;
			GetClientRect(hwnd, &rect);
			int width = GetSystemMetrics(SM_CXSCREEN);
			int height = GetSystemMetrics(SM_CYSCREEN);
			MoveWindow(hwnd, width / 2 - 170, height / 2 - 105, 315, 255, TRUE);

			// set button state; 0 means loglist is hidden, 1 means it's visible
			SetWindowLong(GetDlgItem(hwnd, ID_SHOWLOGBUT), GWL_USERDATA, (LONG)0);

			// add tooltips
			CreateToolTip(hwnd, GetModuleHandle(0));
			AddToolTip(GetDlgItem(hwnd, ID_SHOWLOGBUT), "Show loglist");
			AddToolTip(GetDlgItem(hwnd, ID_X), "Exit");
			AddToolTip(GetDlgItem(hwnd, ID_V), "Add to taskbar notification area");

			// enable autostart checkbox if necessary
			if (isAutoStartEnabled())
				SendMessage(GetDlgItem(hwnd, ID_AUTOSTARTCHECK), BM_SETCHECK, BST_CHECKED, 0);

			// check if dll is loaded
			if (CheckStatus(hwnd))
				EnableWindow(GetDlgItem(hwnd, ID_INJECT), FALSE);
			else
				// when dll is not loaded, get colors from registry; else color variables
				// are already initialized
			{
				GetColorsFromReg();
				InvalidateRect(hwnd, NULL, TRUE);
			}

			// load old variable if there is some
			if (LoadInfoFromFile())
			{
				AddToList("Old data found & loaded...");
				DeleteFile("info.dmp");
			}

			// give our window some text
			SetWindowText(hwnd, "Sunshine's Desktop Symbol Utility");


		}
		break;


	case WM_NOTIFYICON:
		{
			if (lParam == WM_LBUTTONDBLCLK)
			{
				RemoveFromTray(hwnd);
				ShowWindow(hwnd, SW_SHOW);
			}
		}
		break;

	case WM_COMMAND:
		{
			switch (wParam)
			{

			case ID_INJECT:
				{
					SaveColorsToReg();
					if (isDropShadowEnabled())
					{
						DisableDropShadows();
						// give the system the information that we changed the drop shadows
						SystemParametersInfo(0x1025,NULL, FALSE, SPIF_SENDCHANGE|SPIF_UPDATEINIFILE);
					}

					bActivate = TRUE;
					Inject();
					if (CheckStatus(hwnd))
						EnableWindow(GetDlgItem(hwnd, ID_INJECT), FALSE);
				}
				break;

			case ID_UNLOAD:
				{
					bActivate = TRUE;
					UnLoad();
					bActivate = FALSE;
					InvalidateRect(hListView, NULL, TRUE);
					if (!CheckStatus(hwnd))		// inactive
					{
						EnableWindow(GetDlgItem(hwnd, ID_INJECT), TRUE);
						DeleteFile("info.dmp");
					}
					// save currently used values in registry
					

				}
				break;

			// user wants to select a new text color
			case ID_TEXTCOLORBUT:
				{
					ShowColorDialog(hwnd, &textColor);
					DrawTextColorPreview(GetDlgItem(hwnd, ID_TEXTCOLORBOX),
										 &textColorPreviewRect, textColor);
					InvalidateRect(hListView, NULL, TRUE);

				}
				break;

			// user wants to select a new text background color
			case ID_TEXTBGCOLORBUT:
				{
					ShowColorDialog(hwnd, &textBgColor);
					DrawTextColorPreview(GetDlgItem(hwnd, ID_TEXTBGCOLORBOX),
										&textBgColorPreviewRect, textBgColor);
					InvalidateRect(hListView, NULL, TRUE);

				}
				break;

			// user selected background color radio button
			case ID_RADIOCOLOR:
				{
					ShowColorDialog(hwnd, &textBgColor);
					DrawTextColorPreview(GetDlgItem(hwnd, ID_TEXTBGCOLORBOX),
										&textBgColorPreviewRect, textBgColor);
					DrawTextColorPreview(GetDlgItem(hwnd, ID_TEXTCOLORBOX),
										&textColorPreviewRect, textColor);

					InvalidateRect(hListView, NULL, TRUE);

				}
				break;

			// user selected transparent background
			case ID_RADIOTRANS:
				{

					InvalidateRect(hwnd, NULL, TRUE);
					UpdateWindow(hwnd);


					DrawTextColorPreview(GetDlgItem(hwnd, ID_TEXTCOLORBOX),
										&textColorPreviewRect, textColor);
					textBgColor = CLR_NONE;
					InvalidateRect(hListView, NULL, TRUE);
				}
				break;

			// close app
			case ID_X:
				{
					SendMessage(hwnd, WM_CLOSE, 0, 0);
				}
				break;

			// add window tp tray
			case ID_V:
				{
					AddToTray(hwnd);
					ShowWindow(hwnd, SW_HIDE);
				}
				break;

			// show about box
			case ID_ABOUT:
				{
					DialogBox(GetModuleHandle(0), MAKEINTRESOURCE(102), hwnd,
								(DLGPROC)AboutBoxProc);
				}
				break;


			// show/hide log list
			case ID_SHOWLOGBUT:
				{
					RECT rect;
					GetWindowRect(hwnd, &rect);
					HWND hBut = GetDlgItem(hwnd, ID_SHOWLOGBUT);

					long butState = GetWindowLong(hBut, GWL_USERDATA);
					if (butState == 0)		// log list is hidden, so show it
					{
						MoveWindow(hwnd, rect.left, rect.top, 315, 328, TRUE);
						SetWindowLong(hBut, GWL_USERDATA, (LONG)1);
						SetWindowText(hBut, "^");

					}
					else if (butState == 1)	// log window is visible, so hide it
					{
						MoveWindow(hwnd, rect.left, rect.top, 315, 255, TRUE);
						SetWindowLong(hBut, GWL_USERDATA, (LONG)0);
						SetWindowText(hBut, "V");
					}

				}
				break;


			// enable/disable autostart option
			case ID_AUTOSTARTCHECK:
				{
					if (SendMessage(GetDlgItem(hwnd, ID_AUTOSTARTCHECK),
									BM_GETCHECK, 0, 0) == BST_CHECKED)
						if (EnableAutoStart())
							AddToList("Autostart option successfully enabled!");
						else
							AddToList("ERROR: Enabling autostart option failed! Enough access rights?");
					else
						if (DisableAutoStart())
							AddToList("Autostart option successfully disabled!");
						else
							AddToList("ERROR: Disabling autostart option failed! Enough access rights?");
				}
				break;

			default:break;

			}
		}
		break;



	default:break;

	}

	return FALSE;
}



/*
 * Entrypoint
 */
int WINAPI WinMain(HINSTANCE hinstance, HINSTANCE hprevinstance, LPSTR lpcmdline, int ncmdshow)
{
	if (!isWindowsXP())
	{
		MessageBox(0, "This utility will just run under Windows XP!", "Sorry",
					MB_OK | MB_ICONSTOP);
		return 0;
	}

	// check if autostart option is enabled
	LPSTR szCmdLine = GetCommandLine();
	int len = lstrlen(szCmdLine);
	int i;
	for (i = len - 1; i > 0; i--)
	{
		if (szCmdLine[i] == ' ')
		{
			if (lstrcmp((LPSTR)(szCmdLine + i), szAutoStart) == 0)
			{
				// ok, found autostart string in commandline, so inject dll and quit
				hDesktopListview = FindWindowEx(FindWindow("Progman", 0), 0, "SHELLDLL_DefView", 0);
				hListView = FindWindowEx(hDesktopListview, 0, "SysListView32", 0);
				if (hListView == NULL)
				{
					MessageBox(0, "ERROR: Could not find desktop window!", "Aborting..", MB_OK | MB_ICONSTOP);
					return 0;
				}
				bActivate = TRUE;
				if (!Inject())
				{
					MessageBox(0, "ERROR: Could not inject dll!", "Aborting..", MB_OK | MB_ICONSTOP);
					return 0;
				}
				bActivate = FALSE;
				if (!DumpInfoToFile())
				{
					MessageBox(0, "ERROR: Could not save data to file! Unloading will fail", "Aborting..", MB_OK | MB_ICONSTOP);
					return 0;
				}

				return 0;

			}
		}
	}

	HINSTANCE hInst = GetModuleHandle(0);
	DialogBoxParamA(hinstance, MAKEINTRESOURCE(101), NULL, (DLGPROC)DlgProc, NULL);

	return 0;
}



/****************************************************************
 * ABOUT BOX
 ***************************************************************/

BOOL AboutBoxProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
		case WM_LBUTTONDOWN:
		{
			ReleaseCapture();
			SendMessage(hwnd, WM_SYSCOMMAND, 0xf012, 0);
		}
		break;

		case WM_CTLCOLORDLG:
		case WM_CTLCOLORSTATIC:
			return (BOOL)(GetStockObject(WHITE_BRUSH));


		case WM_COMMAND:
			{
				switch (wParam)
				{
				case ID_X:
					EndDialog(hwnd, 0);
					break;

				default:break;
				}
			}
			break;

		default:break;
	}
	return FALSE;
}