/*
 * Tool Tip Helper Routines.
 * Part of Sunshine's Desktop Symbol Utility V1
 */
#include "ToolTip.h"

HWND		hToolTip = NULL;
HINSTANCE	hInstance = NULL;


BOOL CreateToolTip(HWND hwnd, HINSTANCE hInst)
{
	if (hInst != NULL && hwnd != NULL)
	{
		hInstance = hInst;
		hToolTip = hwnd;
	}
	else
		return FALSE;

	hToolTip = CreateWindowEx(WS_EX_TOPMOST, TOOLTIPS_CLASS, NULL,
								TTS_ALWAYSTIP | TTS_NOPREFIX | WS_POPUP,
								CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
								CW_USEDEFAULT, hwnd, 0, hInstance, NULL);
	if (hToolTip)
	{
		// tooltip window is topmost
		SetWindowPos(hToolTip, HWND_TOPMOST, 0, 0, 0, 0, 
				SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
		return TRUE;
	}
	return FALSE;
}

BOOL DeleteToolTip()
{
	if (hToolTip)
		return DestroyWindow(hToolTip);
	return FALSE;
}

BOOL AddToolTip(HWND hwnd, LPSTR text)
{
	if (!hToolTip) return FALSE;

	TOOLINFO	ti;
	RECT		rect;

	if ( (hwnd ) && (GetClientRect(hwnd, &rect)) ) 
	{
		ZeroMemory(&ti, sizeof(TOOLINFO));

		ti.cbSize   = sizeof(TOOLINFO);
		ti.uFlags   = TTF_SUBCLASS | TTF_IDISHWND;
		ti.hwnd     = hwnd;
		ti.uId      = (INT_PTR)hwnd;
		ti.rect     = rect;
		ti.hinst    = hInstance;
		ti.lpszText = text;
		      
		if (SendMessage(hToolTip,TTM_ADDTOOL,0,(LPARAM)&ti)) 
			return TRUE;
		else return FALSE;
	}
	return FALSE;
}
